#ifndef __CAN_H
#define __CAN_H

#include <stdio.h>

#include "inc-gen/data_dictionary.h"

// types
typedef const char* PORT_T;

// init, terminate, prepare
void can_init();
void can_terminate();

void prepare_input_CanConnector();
void finish_input_CanConnector();

void prepare_output_CanConnector();
void finish_output_CanConnector();

// NOVAL
GEN_TYPE_boolean can_is_noval(PORT_T port);
GEN_TYPE_boolean can_set_noval(PORT_T port);

// readers
GEN_TYPE_boolean can_read_bool(PORT_T port);
GEN_TYPE_double can_read_double(PORT_T port);
GEN_TYPE_int can_read_int(PORT_T port);

// writers
void can_write_bool(PORT_T port, GEN_TYPE_boolean value);
void can_write_double(PORT_T port, GEN_TYPE_double value);
void can_write_int(PORT_T port, GEN_TYPE_int value);

#endif // __CAN_H
